package com.zksy.controller.info;

import cn.hutool.core.date.DateTime;
import com.zksy.info.domain.EQuarterlyWaterUsage;
import com.zksy.info.service.EQuarterlyWaterUsageService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 用水控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/equarterlyWaterUsage")
@Api(tags = "用水信息",description = "用水信息desc")
public class EQuarterlyWaterUsageController {
    @Autowired
    private EQuarterlyWaterUsageService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "用水信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String unitName,String unifiedSocialCreditCode,String annual,String isCurrentlyInArrears){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, unitName,unifiedSocialCreditCode,annual,isCurrentlyInArrears));
    }
    @GetMapping("/getEQuarterlyWaterUsageList")
    @ApiOperation(value = "用水信息查询")
    public AjaxResult getEQuarterlyWaterUsageList(String unitName,String unifiedSocialCreditCode,String annual,String isCurrentlyInArrears){
        return AjaxResult.success(service.getEQuarterlyWaterUsageList(unitName,unifiedSocialCreditCode,annual,isCurrentlyInArrears));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询用水信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "用水信息保存")
    public AjaxResult save(@RequestBody EQuarterlyWaterUsage ewater) {
        return service.save(ewater) ? AjaxResult.success(ewater) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "用水信息修改")
    public AjaxResult update(@RequestBody EQuarterlyWaterUsage ewater) {
        ewater.setUpdateTime(LocalDateTime.now());
        return service.updateById(ewater) ? AjaxResult.success(ewater) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "用水信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EQuarterlyWaterUsage.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String unitName,String unifiedSocialCreditCode,String annual,String isCurrentlyInArrears) {
        ExcelExportUtil.exportExcel(response,service.getEQuarterlyWaterUsageList(unitName,unifiedSocialCreditCode,annual,isCurrentlyInArrears), EQuarterlyWaterUsage.class, "用水信息","用水信息");
    }

}
